unit Unit3;

interface

uses windows, graphics, sysutils;

const OFN_EXPLORER = $00080000;
      OFN_NONETWORKBUTTON = $00020000;
      OFN_HIDEREADONLY = $00000004;
      b1x=7;   //    
      b1y=7;
      b1w=75;
      b1h=25;

      b2x=7;       c1x=7;      c3x=7;
      b2y=40;      c1y=105;    c3y=147;
      b2w=75;      c1w=60;     c3w=60;
      b2h=25;      c1h=20;     c3h=20;

      b3x=7;       c2x=7;      c4x=7;
      b3y=73;      c2y=126;    c4y=168;
      b3w=75;      c2w=60;     c4w=60;
      b3h=25;      c2h=20;     c4h=20;

type
 trgb = record  //,      ,     
  b,g,r: byte;
 end;

 ARGB = array [0..0] of TRGB;
 PARGB = ^ARGB;

 poin = record
  x,y:extended; // . 
  dx,dy:extended;//   
 end;

 rec = record
  w,h:cardinal; //  / 
  centr:poin;// ,    ""
  delta:extended; //       
  mass:extended; //  ,   
  color:trgb; //    
 end;

 tagOFNA = packed record
  lStructSize: DWORD;
  hWndOwner: HWND;
  hInstance: HINST;
  lpstrFilter: PAnsiChar;
  lpstrCustomFilter: PAnsiChar;
  nMaxCustFilter: DWORD;
  nFilterIndex: DWORD;
  lpstrFile: PAnsiChar;
  nMaxFile: DWORD;
  lpstrFileTitle: PAnsiChar;
  nMaxFileTitle: DWORD;
  lpstrInitialDir: PAnsiChar;
  lpstrTitle: PAnsiChar;
  Flags: DWORD;
  nFileOffset: Word;
  nFileExtension: Word;
  lpstrDefExt: PAnsiChar;
  lCustData: LPARAM;
  lpfnHook: function(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): UINT stdcall;
  lpTemplateName: PAnsiChar;
 end;

var
  MainWND:thandle;
  hFontBold: THandle;
  WC: TWndClass;
  Mesg:TMsg;
  but1,but2,but3,ch1,ch2,ch3,ch4: THandle;

  sour: tbitmap; //,   
  px,py: integer; //    
  prevx, prevy: integer; //      
  Rprevx, Rprevy: integer; //       
  drawtrig: boolean = false;
  dragtrig: boolean = false;
  filename:string;
  ps,pr:array of PARGB;  //       Pointer Sours, Pointer Result
  shad:integer;
  orw,orh:integer; //      
  points: array of poin;
  rects: array of rec;
  activ, trig, rn:boolean;//    
  wrt,grt,r1,r2:trect;   //Work RecT (  ) Graphic RecT
  count:cardinal;
  Thr: longword;
  ofn: tagOFNA;
  oFilterIndex: DWORD;
  walls, col:boolean; //   /   
  gravity:integer;

function GetMid(t:trect):trgb;
procedure Concrete(rect:trect);
procedure Concrete2(rect:trect; s:char);
procedure DrawFrame;

implementation

function GetMid(t:trect):trgb;
 var i,j:integer;
     r,g,b:int64;
begin
 r:=0;
 g:=0;
 b:=0;
 for i:=t.Top to t.Bottom do
  for j:=t.Left to t.Right do begin
   r:=r+ps[i,j].r;
   g:=g+ps[i,j].g;
   b:=b+ps[i,j].b;
  end;
 i:=(t.Bottom-t.Top+1)*(t.Right-t.Left+1);
 result.r:=r div i;
 result.g:=g div i;
 result.b:=b div i;
end;

procedure DrawFrame;
 var i,n,m,x,y,x1,y1:integer;
 d1:hdc;
begin
  sour.Canvas.FillRect(grt);
  for i:=0 to high(rects) do begin   // 
   y:=round(rects[i].centr.y-rects[i].delta);
   x:=round(rects[i].centr.x-rects[i].delta);
   for n:=0 to rects[i].h do
    for m:=0 to rects[i].w do begin
     y1:=y+n;
     x1:=x+m;
     if (y1>0)and(x1>0)and(y1<orh)and(x1<orw) then begin
      ps[y1,x1].r:=rects[i].color.r;
      ps[y1,x1].g:=rects[i].color.g;
      ps[y1,x1].b:=rects[i].color.b;
     end;
    end;
  end;

 d1:=getdc(mainwnd);
 bitblt(d1,px+1,py+1,orw,orh,sour.Canvas.Handle,1,1,srccopy); //  
 releasedc(mainwnd,d1);
end;

procedure Concrete(rect:trect);
 function GetMiddle(t:trect):extended;
  var i,j:integer;
 begin
  result:=0;
  for i:=t.Top to t.Bottom do
   for j:=t.Left to t.Right do
    result:=result+ps[i,j].r;
  result:=result/((t.Bottom-t.Top+1)*(t.Right-t.Left+1));
 end;
                                                    
 var bal:extended;                    // 1 2
     rec1,rec2,rec3,rec4,rec5:trect;  // 3 4
     w,h:integer; 
     trigger:boolean;
begin
 trigger:=false; //     
 w:=rect.Right-rect.Left; //     (-1)
 h:=rect.Bottom-rect.Top;
 if w>h then begin //     , ...
  rec5.Right:=rect.Right;
  rect.right:=rect.Left+h; //    
  trigger:=true;
  rec5.Left:=rect.right+1; //    
  rec5.Top:=rect.Top;
  rec5.Bottom:=rect.Bottom;
  w:=h;
 end;
 if w<h then begin
  rec5.Bottom:=rect.Bottom;
  rect.Bottom:=rect.Top+w;
  trigger:=true;
  rec5.Left:=rect.Left;
  rec5.Top:=rect.Bottom+1;
  rec5.Right:=rect.Right;
  h:=w;  
 end;

 bal:=GetMiddle(rect); //     R  

 if bal=0 then begin  //   
  setlength(rects,length(rects)+1); //  
  rects[high(rects)].w:=w;
  rects[high(rects)].h:=h;
  rects[high(rects)].delta:=w/2;
  rects[high(rects)].centr.x:=rect.Left+rects[high(rects)].delta;
  rects[high(rects)].centr.y:=rect.Top+rects[high(rects)].delta;
  rects[high(rects)].mass:=(w+1)*(h+1);
  rects[high(rects)].centr.dx:=0;
  rects[high(rects)].centr.dy:=0;
  if col then begin
   rects[high(rects)].color.r:=random(220);
   rects[high(rects)].color.g:=random(220);
   rects[high(rects)].color.b:=random(220);
  end else begin
   rects[high(rects)].color.r:=0;
   rects[high(rects)].color.g:=0;
   rects[high(rects)].color.b:=0;
  end;
  sour.Canvas.Brush.Color:=rects[high(rects)].color.r+255*rects[high(rects)].color.g+65535*rects[high(rects)].color.b;
  inc(rect.Bottom);//    ,     
  inc(rect.Right);
  sour.Canvas.FillRect(rect);

  if trigger then Concrete(rec5);
  exit;
 end;

 if bal=255 then begin   // 
  if trigger then Concrete(rec5);
  exit;
 end;

 rec1.Top:=rect.Top;
 rec1.Left:=rect.Left;
 rec1.Right:=rec1.Left+(w div 2);
 rec1.Bottom:=rec1.Top+(h div 2);

 rec2.Top:=rect.Top;
 rec2.Left:=rec1.Right+1;
 rec2.Right:=rect.Right;
 rec2.Bottom:=rec1.Bottom;

 rec3.Top:=rec1.Bottom+1;
 rec3.Left:=rect.Left;
 rec3.Right:=rec1.Right;
 rec3.Bottom:=rect.Bottom;

 rec4.Top:=rec3.Top;
 rec4.Left:=rec2.Left;
 rec4.Right:=rect.Right;
 rec4.Bottom:=rect.Bottom;

 concrete(rec1);
 concrete(rec2);
 concrete(rec3);
 concrete(rec4);

 if trigger then Concrete(rec5);
end;


procedure Concrete2(rect:trect; s:char);
 function GetMiddle(t:trect):extended;
  var i,j:integer;
 begin
  result:=0;
  for i:=t.Top to t.Bottom do
   for j:=t.Left to t.Right do
    result:=result+ps[i,j].r;
  result:=result/((t.Bottom-t.Top+1)*(t.Right-t.Left+1));
 end;

 var bal:extended;
     rec1,rec2:trect;
     w,h:integer; 
begin
 w:=rect.Right-rect.Left; //     (-1)
 h:=rect.Bottom-rect.Top;
 
 bal:=GetMiddle(rect); //     R  

 if bal=0 then begin  //   
  setlength(rects,length(rects)+1); //  
  rects[high(rects)].w:=w;
  rects[high(rects)].h:=h;
  rects[high(rects)].delta:=w/2;
  rects[high(rects)].centr.x:=rect.Left+rects[high(rects)].delta;
  rects[high(rects)].centr.y:=rect.Top+rects[high(rects)].delta;
  rects[high(rects)].mass:=(w+1)*(h+1);
  rects[high(rects)].centr.dx:=0;
  rects[high(rects)].centr.dy:=0;
  if col then begin
   rects[high(rects)].color.r:=random(220);
   rects[high(rects)].color.g:=random(220);
   rects[high(rects)].color.b:=random(220);
  end else begin
   rects[high(rects)].color.r:=0;
   rects[high(rects)].color.g:=0;
   rects[high(rects)].color.b:=0;
  end;
  sour.Canvas.Brush.Color:=rects[high(rects)].color.r+255*rects[high(rects)].color.g+65535*rects[high(rects)].color.b;
  inc(rect.Bottom);//    ,     
  inc(rect.Right);
  sour.Canvas.FillRect(rect);
  exit;
 end;

 if bal=255 then exit;

 if s='V' then begin // Vertical separation
  rec1.Top:=rect.Top;
  rec1.Bottom:=rect.bottom;
  rec1.Left:=rect.left;
  rec1.Right:=rect.left+(rect.Right-rect.Left)div 2;

  rec2.Top:=rect.Top;
  rec2.Bottom:=rect.Bottom;
  rec2.Left:=rec1.Right+1;
  rec2.Right:=rect.Right;

  if rec1.Right>=rec1.Left then concrete2(rec1,'H');
  if rec2.Right>=rec2.Left then concrete2(rec2,'H');
 end else begin  //  Horizontal separation
  rec1.Left:=rect.Left;
  rec1.Right:=rect.Right;
  rec1.Top:=rect.Top;
  rec1.Bottom:=rect.Top+(rect.bottom-rect.top)div 2;

  rec2.Left:=rect.Left;
  rec2.Right:=rect.Right;
  rec2.Top:=rec1.bottom+1;
  rec2.Bottom:=rect.Bottom;

  if rec1.bottom>=rec1.top then concrete2(rec1,'V');
  if rec2.bottom>=rec2.top then concrete2(rec2,'V');
 end;
end;

end.
